import time
from pyModbusTCP.client import ModbusClient

c = ModbusClient(
	host="challenges.france-cybersecurity-challenge.fr",
	port=502, unit_id=1)
# c.debug(True)
c.open()

# ------
# read token (done 1st so I can see mistakes in SCADA)
token = c.read_holding_registers(0,32)
print("Token: " + str(token))
if not token:
    print("Token reading failed")
    exit(1)

asciiToken = "".join(map(chr,token))
print("ASCIIToken: " + asciiToken)

# ------
# C'est parti pour le mélange des couleurs
# Remplir F avec RGB(32,126,42) en moins de 90 secondes
# Le mieux semblerait d'être de remplir M avec 32,32,32

print("Putting R=16,G=68,B=16")
c.write_single_register(32,1)
c.write_single_register(33,4)
c.write_single_register(34,1) # Set Flows
c.write_single_coil(0,True)
c.write_single_coil(1,True)
c.write_single_coil(2,True) # Open valves
while (c.read_input_registers(0,1)[0]>(255-16)): # Wait for goal
	pass
c.write_single_coil(0,False)
#c.write_single_coil(1,False)
c.write_single_coil(2,False) # Stop flows

while (c.read_input_registers(1,1)[0]>(255-68)):
	pass
	
print("Flushing M")
c.write_single_register(35,4)
c.write_single_coil(3,True)
while (c.read_input_registers(6,1)[0]>0):
	pass
c.write_single_coil(3,False)
print("Expected: R=16,G=68,B=16")

print("Putting R=16,G=58,B=26")
c.write_single_register(32,1)
c.write_single_register(33,4)
c.write_single_register(34,2) # Set Flows
c.write_single_coil(0,True)
c.write_single_coil(1,True)
c.write_single_coil(2,True) # Open valves
while (c.read_input_registers(2,1)[0]>(255-42)): # Wait for goal (B first)
	pass
c.write_single_coil(2,False) # Stop Blue
c.write_single_register(33,1) # Slow green down (irrealistic behavior)
while (c.read_input_registers(0,1)[0]>(255-32)): # Wait for goal (R second)
	pass
c.write_single_coil(0,False) # Stop Red
while (c.read_input_registers(1,1)[0]>(255-126)): # Wait for G
	pass

print("Flushing M")
c.write_single_register(35,4)
c.write_single_coil(3,True)
while (c.read_input_registers(6,1)[0]>0):
	pass

print("Finished!")

# -------------------
# Check result in SCADA
# Sleeping to keep TCP open
print("Sleeping...")
time.sleep(300)

exit(0)
# flag: FCSC{3518dcd9579b4f2bf4ab32f126aa746e00767d6b130ef6c2e79ae6a313d0ba07}

# This below was for testing
# On va tout lire déjà, pour faire le point
# cf https://pymodbustcp.readthedocs.io/en/stable/package/class_ModbusClient.html#pyModbusTCP.client.ModbusClient.read_coils
debitR = c.read_holding_registers(32,1)[0]
debitG = c.read_holding_registers(33,1)[0]
debitB = c.read_holding_registers(34,1)[0]
debitM = c.read_holding_registers(35,1)[0]

vannR = c.read_coils(0,1)[0]
vannG = c.read_coils(1,1)[0]
vannB = c.read_coils(2,1)[0]
vannM = c.read_coils(3,1)[0] # M basse

unitR = c.read_input_registers(0,1)[0]
unitG = c.read_input_registers(1,1)[0]
unitB = c.read_input_registers(2,1)[0]
unitRM = c.read_input_registers(3,1)[0]
unitGM = c.read_input_registers(4,1)[0]
unitBM = c.read_input_registers(5,1)[0]
unitM = c.read_input_registers(6,1)[0]
unitRF = c.read_input_registers(7,1)[0]
unitGF = c.read_input_registers(8,1)[0]
unitBF = c.read_input_registers(9,1)[0]
unitF = c.read_input_registers(10,1)[0]

vanneHaute = c.read_discrete_inputs(0,1)	# This fails

print("debitR="+str(debitR))	# 1
print("debitG="+str(debitG))	# 1
print("debitB="+str(debitB))	# 1
print("debitM="+str(debitM))	# 1
print("vannR="+str(vannR))	# False
print("vannG="+str(vannG))	# False
print("vannB="+str(vannB))	# False
print("vannM="+str(vannM))	# False
print("unitR="+str(unitR))	# 255
print("unitG="+str(unitG))	# 255
print("unitB="+str(unitB))	# 255
print("unitRM="+str(unitRM))	# 0
print("unitGM="+str(unitGM))	# 0
print("unitBM="+str(unitBM))	# 0
print("unitM="+str(unitM))	# 0
print("unitRF="+str(unitRF))	# 0
print("unitGF="+str(unitGF))	# 0
print("unitBF="+str(unitBF))	# 0
print("unitF="+str(unitF))	# 0
print("vanneHaute="+str(vanneHaute))	# "None"

# Sleep pour garder la connection ouverte
print("Sleeping now...")
time.sleep(60)


